package com.objis.demohibernate.test;

import java.util.Date;
import java.util.Set;

import com.objis.demohibernate.domaine.Formateur;
import com.objis.demohibernate.domaine.Formation;
import com.objis.demohibernate.domaine.FormationInter;
import com.objis.demohibernate.domaine.FormationIntra;
import com.objis.demohibernate.domaine.Lieu;
import com.objis.demohibernate.service.GestionnaireFormation;

import junit.framework.TestCase;

public class GestionnaireFormationTest extends TestCase {

	// Tester la cration d'une Formation. Teste cl primaire retourne
	public void testCreerFormation() {
		GestionnaireFormation serviceGestionnaire = new GestionnaireFormation();	

		Lieu lieu1 = new Lieu("Objis","centre d'affaire Regus, 72 rue du Faubourg St Honor , 75008 Paris");
		Lieu lieu2 = new Lieu("So@t","104 bis, rue de Reuilly, 75012 Paris");

		Formateur formateur1 = new Formateur("Mbiandou", "Douglas", 10);
		Formateur formateur2 = new Formateur("Fontan", "Yannick", 10);

		Set<Formateur> formateurs = new java.util.HashSet<Formateur>(2);
		formateurs.add(formateur1);
		formateurs.add(formateur2);

		// 3 : Utilisation du service
		serviceGestionnaire.creerFormation(new Formation("Hibernate",new Date(),3,lieu2,formateurs));
		serviceGestionnaire.creerFormation(new FormationInter("Struts",new Date(),3,lieu1,formateurs,2));
		serviceGestionnaire.creerFormation(new FormationIntra("Spring",new Date(),3,lieu1,formateurs,"oui"));
		serviceGestionnaire.creerFormation(new FormationIntra("Ajax",new Date(),3,lieu1,formateurs,"oui"));
		serviceGestionnaire.creerFormation(new FormationIntra("Selenium",new Date(),3,lieu2,formateurs,"oui"));

		Formation formation = new Formation("EJB3");	
		Long id = serviceGestionnaire.creerFormation(formation);
		assertNotNull(id);
	}

	// Tester DemoMerge1
	public void testDemoMerge1() {
		GestionnaireFormation gestionnaire = new GestionnaireFormation();	
		Throwable e = null;
		try {
			gestionnaire.demoMerge1();
		} catch (Throwable ex) {
			e = ex;
			System.out.println("##### ERROR : " + e.getClass());
		}
		assertTrue(e instanceof org.hibernate.NonUniqueObjectException);
	}

	// Tester DemoMerge2
	public void testDemoMerge2() {
		GestionnaireFormation gestionnaire = new GestionnaireFormation();	
		gestionnaire.demoMerge2();
		Formation f = gestionnaire.getFormation(new Long(3));
		assertEquals("ajax", f.getTheme());
	}

	// Tester DemoMerge3
	public void testDemoMerge3() {
		GestionnaireFormation gestionnaire = new GestionnaireFormation();	
		gestionnaire.demoMerge3();
		Formation f = gestionnaire.getFormation(new Long(3));
		assertEquals("ajax", f.getTheme());
	}
}
